/// <reference path="./custom.d.ts" />
// tslint:disable
/**
 * Snippets API
 * Test description
 *
 * OpenAPI spec version: v1
 * Contact: contact@snippets.local
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


import * as url from "url";
import * as portableFetch from "portable-fetch";
import { Configuration } from "./configuration";

const BASE_PATH = "http://localhost:8000/swiftlyrics".replace(/\/+$/, "");

/**
 *
 * @export
 */
export const COLLECTION_FORMATS = {
    csv: ",",
    ssv: " ",
    tsv: "\t",
    pipes: "|",
};

/**
 *
 * @export
 * @interface FetchAPI
 */
export interface FetchAPI {
    (url: string, init?: any): Promise<Response>;
}

/**
 *
 * @export
 * @interface FetchArgs
 */
export interface FetchArgs {
    url: string;
    options: any;
}

/**
 *
 * @export
 * @class BaseAPI
 */
export class BaseAPI {
    protected configuration: Configuration= new Configuration(
        
    );

    constructor(configuration?: Configuration, protected basePath: string = BASE_PATH, protected fetch: FetchAPI = portableFetch) {
        if (configuration) {
            this.configuration = configuration;
            this.basePath = configuration.basePath || this.basePath;
        }
    }
};

/**
 *
 * @export
 * @class RequiredError
 * @extends {Error}
 */
export class RequiredError extends Error {
    // name: "RequiredError"
    constructor(public field: string, msg?: string) {
        super(msg);
    }
}

/**
 * 
 * @export
 * @interface AlbumDetail
 */
export interface AlbumDetail {
    /**
     * 
     * @type {number}
     * @memberof AlbumDetail
     */
    id?: number;
    /**
     * Album name - can alternatively use 'id' field set to id of existing album when creating new lyrics
     * @type {string}
     * @memberof AlbumDetail
     */
    name: string;
    /**
     * 
     * @type {number}
     * @memberof AlbumDetail
     */
    year?: number;
    /**
     * 
     * @type {number}
     * @memberof AlbumDetail
     */
    artist?: number;
    /**
     * 
     * @type {string}
     * @memberof AlbumDetail
     */
    artistName?: string;
    /**
     * 
     * @type {Array<BaseSong>}
     * @memberof AlbumDetail
     */
    songs?: Array<BaseSong>;
}

/**
 * 
 * @export
 * @interface Artist
 */
export interface Artist {
    /**
     * Artist name - Artist name name required
     * @type {string}
     * @memberof Artist
     */
    name: string;
    /**
     * 
     * @type {number}
     * @memberof Artist
     */
    firstYear?: number;
    /**
     * 
     * @type {number}
     * @memberof Artist
     */
    id?: number;
}

/**
 * 
 * @export
 * @interface ArtistDetail
 */
export interface ArtistDetail {
    /**
     * 
     * @type {number}
     * @memberof ArtistDetail
     */
    id?: number;
    /**
     * Artist name - Artist name name required
     * @type {string}
     * @memberof ArtistDetail
     */
    name: string;
    /**
     * 
     * @type {number}
     * @memberof ArtistDetail
     */
    firstYear?: number;
    /**
     * 
     * @type {Array<CustomAlbum>}
     * @memberof ArtistDetail
     */
    albums?: Array<CustomAlbum>;
}

/**
 * 
 * @export
 * @interface BaseAlbum
 */
export interface BaseAlbum {
    /**
     * 
     * @type {number}
     * @memberof BaseAlbum
     */
    id?: number;
    /**
     * Album name - can alternatively use 'id' field set to id of existing album when creating new lyrics
     * @type {string}
     * @memberof BaseAlbum
     */
    name: string;
    /**
     * 
     * @type {number}
     * @memberof BaseAlbum
     */
    year?: number;
    /**
     * 
     * @type {number}
     * @memberof BaseAlbum
     */
    artist?: number;
    /**
     * 
     * @type {string}
     * @memberof BaseAlbum
     */
    artistName?: string;
}

/**
 * 
 * @export
 * @interface BaseSong
 */
export interface BaseSong {
    /**
     * 
     * @type {number}
     * @memberof BaseSong
     */
    id?: number;
    /**
     * Song name - can alternatively use 'id' field set to id of existing song when creating new lyrics
     * @type {string}
     * @memberof BaseSong
     */
    name: string;
    /**
     * 
     * @type {string}
     * @memberof BaseSong
     */
    albumName?: string;
    /**
     * 
     * @type {string}
     * @memberof BaseSong
     */
    artistName?: string;
}

/**
 * 
 * @export
 * @interface CustomAlbum
 */
export interface CustomAlbum {
    /**
     * 
     * @type {number}
     * @memberof CustomAlbum
     */
    id?: number;
    /**
     * Album name - can alternatively use 'id' field set to id of existing album when creating new lyrics
     * @type {string}
     * @memberof CustomAlbum
     */
    name: string;
}

/**
 * 
 * @export
 * @interface Lyric
 */
export interface Lyric {
    /**
     * 
     * @type {number}
     * @memberof Lyric
     */
    id?: number;
    /**
     * Lyrics from a song/album
     * @type {string}
     * @memberof Lyric
     */
    text: string;
    /**
     * 
     * @type {number}
     * @memberof Lyric
     */
    votes?: number;
    /**
     * Number of upvotes for the current lyric
     * @type {number}
     * @memberof Lyric
     */
    upvote?: number;
    /**
     * Number of downvotes for the current lyric
     * @type {number}
     * @memberof Lyric
     */
    downvote?: number;
    /**
     * 
     * @type {string}
     * @memberof Lyric
     */
    currentAlbum?: string;
}

/**
 * 
 * @export
 * @interface LyricDetail
 */
export interface LyricDetail {
    /**
     * 
     * @type {number}
     * @memberof LyricDetail
     */
    id?: number;
    /**
     * Lyrics from a song/album
     * @type {string}
     * @memberof LyricDetail
     */
    text: string;
    /**
     * 
     * @type {number}
     * @memberof LyricDetail
     */
    votes?: number;
    /**
     * Number of upvotes for the current lyric
     * @type {number}
     * @memberof LyricDetail
     */
    upvote?: number;
    /**
     * Number of downvotes for the current lyric
     * @type {number}
     * @memberof LyricDetail
     */
    downvote?: number;
    /**
     * 
     * @type {string}
     * @memberof LyricDetail
     */
    currentAlbum?: string;
    /**
     * 
     * @type {BaseSong}
     * @memberof LyricDetail
     */
    song?: BaseSong;
    /**
     * 
     * @type {number}
     * @memberof LyricDetail
     */
    album: number;
}

/**
 * 
 * @export
 * @interface LyricVote
 */
export interface LyricVote {
    /**
     * 
     * @type {number}
     * @memberof LyricVote
     */
    id?: number;
    /**
     * Number of upvotes for the current lyric
     * @type {number}
     * @memberof LyricVote
     */
    upvote?: number;
    /**
     * Number of downvotes for the current lyric
     * @type {number}
     * @memberof LyricVote
     */
    downvote?: number;
}

/**
 * 
 * @export
 * @interface RandomLyricDetail
 */
export interface RandomLyricDetail {
    /**
     * 
     * @type {number}
     * @memberof RandomLyricDetail
     */
    id?: number;
    /**
     * Lyrics from a song/album
     * @type {string}
     * @memberof RandomLyricDetail
     */
    text: string;
}

/**
 * 
 * @export
 * @interface Song
 */
export interface Song {
    /**
     * 
     * @type {number}
     * @memberof Song
     */
    id?: number;
    /**
     * Song name - can alternatively use 'id' field set to id of existing song when creating new lyrics
     * @type {string}
     * @memberof Song
     */
    name: string;
    /**
     * 
     * @type {string}
     * @memberof Song
     */
    albumName?: string;
    /**
     * 
     * @type {string}
     * @memberof Song
     */
    artistName?: string;
    /**
     * 
     * @type {BaseAlbum}
     * @memberof Song
     */
    album: BaseAlbum;
}

/**
 * 
 * @export
 * @interface SongDetail
 */
export interface SongDetail {
    /**
     * 
     * @type {number}
     * @memberof SongDetail
     */
    id?: number;
    /**
     * Song name - can alternatively use 'id' field set to id of existing song when creating new lyrics
     * @type {string}
     * @memberof SongDetail
     */
    name: string;
    /**
     * 
     * @type {string}
     * @memberof SongDetail
     */
    albumName?: string;
    /**
     * 
     * @type {string}
     * @memberof SongDetail
     */
    artistName?: string;
    /**
     * 
     * @type {BaseAlbum}
     * @memberof SongDetail
     */
    album: BaseAlbum;
    /**
     * 
     * @type {Array<Lyric>}
     * @memberof SongDetail
     */
    lyrics?: Array<Lyric>;
}


/**
 * AlbumApi - fetch parameter creator
 * @export
 */
export const AlbumApiFetchParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @param {BaseAlbum} data 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        albumCreate(data: BaseAlbum, options: any = {}): FetchArgs {
            // verify required parameter 'data' is not null or undefined
            if (data === null || data === undefined) {
                throw new RequiredError('data','Required parameter data was null or undefined when calling albumCreate.');
            }
            const localVarPath = `/album/`;
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'POST' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Basic required
            // http basic authentication required
            if (configuration && (configuration.username || configuration.password)) {
                localVarHeaderParameter["Authorization"] = "Basic " + btoa(configuration.username + ":" + configuration.password);
            }

            localVarHeaderParameter['Content-Type'] = 'application/json';

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            const needsSerialization = (<any>"BaseAlbum" !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.body =  needsSerialization ? JSON.stringify(data || {}) : (data || "");

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        albumDelete(id: string, options: any = {}): FetchArgs {
            // verify required parameter 'id' is not null or undefined
            if (id === null || id === undefined) {
                throw new RequiredError('id','Required parameter id was null or undefined when calling albumDelete.');
            }
            const localVarPath = `/album/{id}/`
                .replace(`{${"id"}}`, encodeURIComponent(String(id)));
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'DELETE' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Basic required
            // http basic authentication required
            if (configuration && (configuration.username || configuration.password)) {
                localVarHeaderParameter["Authorization"] = "Basic " + btoa(configuration.username + ":" + configuration.password);
            }

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @param {number} [page] A page number within the paginated result set.
         * @param {number} [size] Number of results to return per page.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        albumList(page?: number, size?: number, options: any = {}): FetchArgs {
            const localVarPath = `/album/`;
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Basic required
            // http basic authentication required
            if (configuration && (configuration.username || configuration.password)) {
                localVarHeaderParameter["Authorization"] = "Basic " + btoa(configuration.username + ":" + configuration.password);
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (size !== undefined) {
                localVarQueryParameter['size'] = size;
            }

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        albumRead(id: string, options: any = {}): FetchArgs {
            // verify required parameter 'id' is not null or undefined
            if (id === null || id === undefined) {
                throw new RequiredError('id','Required parameter id was null or undefined when calling albumRead.');
            }
            const localVarPath = `/album/{id}/`
                .replace(`{${"id"}}`, encodeURIComponent(String(id)));
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Basic required
            // http basic authentication required
            if (configuration && (configuration.username || configuration.password)) {
                localVarHeaderParameter["Authorization"] = "Basic " + btoa(configuration.username + ":" + configuration.password);
            }

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * AlbumApi - functional programming interface
 * @export
 */
export const AlbumApiFp = function(configuration?: Configuration) {
    return {
        /**
         * 
         * @param {BaseAlbum} data 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        albumCreate(data: BaseAlbum, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<BaseAlbum> {
            const localVarFetchArgs = AlbumApiFetchParamCreator(configuration).albumCreate(data, options);
            return (fetch: FetchAPI = portableFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * 
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        albumDelete(id: string, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<Response> {
            const localVarFetchArgs = AlbumApiFetchParamCreator(configuration).albumDelete(id, options);
            return (fetch: FetchAPI = portableFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response;
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * 
         * @param {number} [page] A page number within the paginated result set.
         * @param {number} [size] Number of results to return per page.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        albumList(page?: number, size?: number, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<any> {
            const localVarFetchArgs = AlbumApiFetchParamCreator(configuration).albumList(page, size, options);
            return (fetch: FetchAPI = portableFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * 
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        albumRead(id: string, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<AlbumDetail> {
            const localVarFetchArgs = AlbumApiFetchParamCreator(configuration).albumRead(id, options);
            return (fetch: FetchAPI = portableFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
    }
};

/**
 * AlbumApi - factory interface
 * @export
 */
export const AlbumApiFactory = function (configuration?: Configuration, fetch?: FetchAPI, basePath?: string) {
    return {
        /**
         * 
         * @param {BaseAlbum} data 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        albumCreate(data: BaseAlbum, options?: any) {
            return AlbumApiFp(configuration).albumCreate(data, options)(fetch, basePath);
        },
        /**
         * 
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        albumDelete(id: string, options?: any) {
            return AlbumApiFp(configuration).albumDelete(id, options)(fetch, basePath);
        },
        /**
         * 
         * @param {number} [page] A page number within the paginated result set.
         * @param {number} [size] Number of results to return per page.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        albumList(page?: number, size?: number, options?: any) {
            return AlbumApiFp(configuration).albumList(page, size, options)(fetch, basePath);
        },
        /**
         * 
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        albumRead(id: string, options?: any) {
            return AlbumApiFp(configuration).albumRead(id, options)(fetch, basePath);
        },
    };
};

/**
 * AlbumApi - object-oriented interface
 * @export
 * @class AlbumApi
 * @extends {BaseAPI}
 */
export class AlbumApi extends BaseAPI {
    /**
     * 
     * @param {BaseAlbum} data 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AlbumApi
     */
    public albumCreate(data: BaseAlbum, options?: any) {
        return AlbumApiFp(this.configuration).albumCreate(data, options)(this.fetch, this.basePath);
    }

    /**
     * 
     * @param {string} id 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AlbumApi
     */
    public albumDelete(id: string, options?: any) {
        return AlbumApiFp(this.configuration).albumDelete(id, options)(this.fetch, this.basePath);
    }

    /**
     * 
     * @param {number} [page] A page number within the paginated result set.
     * @param {number} [size] Number of results to return per page.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AlbumApi
     */
    public albumList(page?: number, size?: number, options?: any) {
        return AlbumApiFp(this.configuration).albumList(page, size, options)(this.fetch, this.basePath);
    }

    /**
     * 
     * @param {string} id 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AlbumApi
     */
    public albumRead(id: string, options?: any) {
        return AlbumApiFp(this.configuration).albumRead(id, options)(this.fetch, this.basePath);
    }

}

/**
 * ArtistApi - fetch parameter creator
 * @export
 */
export const ArtistApiFetchParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @param {Artist} data 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        artistCreate(data: Artist, options: any = {}): FetchArgs {
            // verify required parameter 'data' is not null or undefined
            if (data === null || data === undefined) {
                throw new RequiredError('data','Required parameter data was null or undefined when calling artistCreate.');
            }
            const localVarPath = `/artist/`;
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'POST' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Basic required
            // http basic authentication required
            if (configuration && (configuration.username || configuration.password)) {
                localVarHeaderParameter["Authorization"] = "Basic " + btoa(configuration.username + ":" + configuration.password);
            }

            localVarHeaderParameter['Content-Type'] = 'application/json';

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            const needsSerialization = (<any>"Artist" !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.body =  needsSerialization ? JSON.stringify(data || {}) : (data || "");

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        artistDelete(id: string, options: any = {}): FetchArgs {
            // verify required parameter 'id' is not null or undefined
            if (id === null || id === undefined) {
                throw new RequiredError('id','Required parameter id was null or undefined when calling artistDelete.');
            }
            const localVarPath = `/artist/{id}/`
                .replace(`{${"id"}}`, encodeURIComponent(String(id)));
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'DELETE' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Basic required
            // http basic authentication required
            if (configuration && (configuration.username || configuration.password)) {
                localVarHeaderParameter["Authorization"] = "Basic " + btoa(configuration.username + ":" + configuration.password);
            }

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @param {string} [ordering] Which field to use when ordering the results.
         * @param {number} [page] A page number within the paginated result set.
         * @param {number} [size] Number of results to return per page.
         * @param {number} [artistYearFilterGt] year of operation greater than this filter
         * @param {number} [artistYearFilterLt] year of operation lower than this filter
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        artistList(ordering?: string, page?: number, size?: number, artistYearFilterGt?: number, artistYearFilterLt?: number, options: any = {}): FetchArgs {
            const localVarPath = `/artist/`;
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Basic required
            // http basic authentication required
            if (configuration && (configuration.username || configuration.password)) {
                localVarHeaderParameter["Authorization"] = "Basic " + btoa(configuration.username + ":" + configuration.password);
            }

            if (ordering !== undefined) {
                localVarQueryParameter['ordering'] = ordering;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (size !== undefined) {
                localVarQueryParameter['size'] = size;
            }

            if (artistYearFilterGt !== undefined) {
                localVarQueryParameter['artist_year_filter_gt'] = artistYearFilterGt;
            }

            if (artistYearFilterLt !== undefined) {
                localVarQueryParameter['artist_year_filter_lt'] = artistYearFilterLt;
            }

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @param {number} [artistFilter] id artist filter
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        artistRandomList(artistFilter?: number, options: any = {}): FetchArgs {
            const localVarPath = `/artist/random/`;
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Basic required
            // http basic authentication required
            if (configuration && (configuration.username || configuration.password)) {
                localVarHeaderParameter["Authorization"] = "Basic " + btoa(configuration.username + ":" + configuration.password);
            }

            if (artistFilter !== undefined) {
                localVarQueryParameter['artist_filter'] = artistFilter;
            }

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        artistRead(id: string, options: any = {}): FetchArgs {
            // verify required parameter 'id' is not null or undefined
            if (id === null || id === undefined) {
                throw new RequiredError('id','Required parameter id was null or undefined when calling artistRead.');
            }
            const localVarPath = `/artist/{id}/`
                .replace(`{${"id"}}`, encodeURIComponent(String(id)));
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Basic required
            // http basic authentication required
            if (configuration && (configuration.username || configuration.password)) {
                localVarHeaderParameter["Authorization"] = "Basic " + btoa(configuration.username + ":" + configuration.password);
            }

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @param {string} id 
         * @param {ArtistDetail} data 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        artistUpdate(id: string, data: ArtistDetail, options: any = {}): FetchArgs {
            // verify required parameter 'id' is not null or undefined
            if (id === null || id === undefined) {
                throw new RequiredError('id','Required parameter id was null or undefined when calling artistUpdate.');
            }
            // verify required parameter 'data' is not null or undefined
            if (data === null || data === undefined) {
                throw new RequiredError('data','Required parameter data was null or undefined when calling artistUpdate.');
            }
            const localVarPath = `/artist/{id}/`
                .replace(`{${"id"}}`, encodeURIComponent(String(id)));
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'PUT' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Basic required
            // http basic authentication required
            if (configuration && (configuration.username || configuration.password)) {
                localVarHeaderParameter["Authorization"] = "Basic " + btoa(configuration.username + ":" + configuration.password);
            }

            localVarHeaderParameter['Content-Type'] = 'application/json';

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            const needsSerialization = (<any>"ArtistDetail" !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.body =  needsSerialization ? JSON.stringify(data || {}) : (data || "");

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * ArtistApi - functional programming interface
 * @export
 */
export const ArtistApiFp = function(configuration?: Configuration) {
    return {
        /**
         * 
         * @param {Artist} data 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        artistCreate(data: Artist, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<Artist> {
            const localVarFetchArgs = ArtistApiFetchParamCreator(configuration).artistCreate(data, options);
            return (fetch: FetchAPI = portableFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * 
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        artistDelete(id: string, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<Response> {
            const localVarFetchArgs = ArtistApiFetchParamCreator(configuration).artistDelete(id, options);
            return (fetch: FetchAPI = portableFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response;
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * 
         * @param {string} [ordering] Which field to use when ordering the results.
         * @param {number} [page] A page number within the paginated result set.
         * @param {number} [size] Number of results to return per page.
         * @param {number} [artistYearFilterGt] year of operation greater than this filter
         * @param {number} [artistYearFilterLt] year of operation lower than this filter
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        artistList(ordering?: string, page?: number, size?: number, artistYearFilterGt?: number, artistYearFilterLt?: number, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<any> {
            const localVarFetchArgs = ArtistApiFetchParamCreator(configuration).artistList(ordering, page, size, artistYearFilterGt, artistYearFilterLt, options);
            return (fetch: FetchAPI = portableFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * 
         * @param {number} [artistFilter] id artist filter
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        artistRandomList(artistFilter?: number, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<RandomLyricDetail> {
            const localVarFetchArgs = ArtistApiFetchParamCreator(configuration).artistRandomList(artistFilter, options);
            return (fetch: FetchAPI = portableFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * 
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        artistRead(id: string, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<ArtistDetail> {
            const localVarFetchArgs = ArtistApiFetchParamCreator(configuration).artistRead(id, options);
            return (fetch: FetchAPI = portableFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * 
         * @param {string} id 
         * @param {ArtistDetail} data 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        artistUpdate(id: string, data: ArtistDetail, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<ArtistDetail> {
            const localVarFetchArgs = ArtistApiFetchParamCreator(configuration).artistUpdate(id, data, options);
            return (fetch: FetchAPI = portableFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
    }
};

/**
 * ArtistApi - factory interface
 * @export
 */
export const ArtistApiFactory = function (configuration?: Configuration, fetch?: FetchAPI, basePath?: string) {
    return {
        /**
         * 
         * @param {Artist} data 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        artistCreate(data: Artist, options?: any) {
            return ArtistApiFp(configuration).artistCreate(data, options)(fetch, basePath);
        },
        /**
         * 
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        artistDelete(id: string, options?: any) {
            return ArtistApiFp(configuration).artistDelete(id, options)(fetch, basePath);
        },
        /**
         * 
         * @param {string} [ordering] Which field to use when ordering the results.
         * @param {number} [page] A page number within the paginated result set.
         * @param {number} [size] Number of results to return per page.
         * @param {number} [artistYearFilterGt] year of operation greater than this filter
         * @param {number} [artistYearFilterLt] year of operation lower than this filter
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        artistList(ordering?: string, page?: number, size?: number, artistYearFilterGt?: number, artistYearFilterLt?: number, options?: any) {
            return ArtistApiFp(configuration).artistList(ordering, page, size, artistYearFilterGt, artistYearFilterLt, options)(fetch, basePath);
        },
        /**
         * 
         * @param {number} [artistFilter] id artist filter
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        artistRandomList(artistFilter?: number, options?: any) {
            return ArtistApiFp(configuration).artistRandomList(artistFilter, options)(fetch, basePath);
        },
        /**
         * 
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        artistRead(id: string, options?: any) {
            return ArtistApiFp(configuration).artistRead(id, options)(fetch, basePath);
        },
        /**
         * 
         * @param {string} id 
         * @param {ArtistDetail} data 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        artistUpdate(id: string, data: ArtistDetail, options?: any) {
            return ArtistApiFp(configuration).artistUpdate(id, data, options)(fetch, basePath);
        },
    };
};

/**
 * ArtistApi - object-oriented interface
 * @export
 * @class ArtistApi
 * @extends {BaseAPI}
 */
export class ArtistApi extends BaseAPI {
    /**
     * 
     * @param {Artist} data 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ArtistApi
     */
    public artistCreate(data: Artist, options?: any) {
        return ArtistApiFp(this.configuration).artistCreate(data, options)(this.fetch, this.basePath);
    }

    /**
     * 
     * @param {string} id 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ArtistApi
     */
    public artistDelete(id: string, options?: any) {
        return ArtistApiFp(this.configuration).artistDelete(id, options)(this.fetch, this.basePath);
    }

    /**
     * 
     * @param {string} [ordering] Which field to use when ordering the results.
     * @param {number} [page] A page number within the paginated result set.
     * @param {number} [size] Number of results to return per page.
     * @param {number} [artistYearFilterGt] year of operation greater than this filter
     * @param {number} [artistYearFilterLt] year of operation lower than this filter
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ArtistApi
     */
    public artistList(ordering?: string, page?: number, size?: number, artistYearFilterGt?: number, artistYearFilterLt?: number, options?: any) {
        return ArtistApiFp(this.configuration).artistList(ordering, page, size, artistYearFilterGt, artistYearFilterLt, options)(this.fetch, this.basePath);
    }

    /**
     * 
     * @param {number} [artistFilter] id artist filter
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ArtistApi
     */
    public artistRandomList(artistFilter?: number, options?: any) {
        return ArtistApiFp(this.configuration).artistRandomList(artistFilter, options)(this.fetch, this.basePath);
    }

    /**
     * 
     * @param {string} id 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ArtistApi
     */
    public artistRead(id: string, options?: any) {
        return ArtistApiFp(this.configuration).artistRead(id, options)(this.fetch, this.basePath);
    }

    /**
     * 
     * @param {string} id 
     * @param {ArtistDetail} data 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ArtistApi
     */
    public artistUpdate(id: string, data: ArtistDetail, options?: any) {
        return ArtistApiFp(this.configuration).artistUpdate(id, data, options)(this.fetch, this.basePath);
    }

}

/**
 * LyricApi - fetch parameter creator
 * @export
 */
export const LyricApiFetchParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @param {LyricDetail} data 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lyricCreate(data: LyricDetail, options: any = {}): FetchArgs {
            // verify required parameter 'data' is not null or undefined
            if (data === null || data === undefined) {
                throw new RequiredError('data','Required parameter data was null or undefined when calling lyricCreate.');
            }
            const localVarPath = `/lyric/`;
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'POST' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Basic required
            // http basic authentication required
            if (configuration && (configuration.username || configuration.password)) {
                localVarHeaderParameter["Authorization"] = "Basic " + btoa(configuration.username + ":" + configuration.password);
            }

            localVarHeaderParameter['Content-Type'] = 'application/json';

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            const needsSerialization = (<any>"LyricDetail" !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.body =  needsSerialization ? JSON.stringify(data || {}) : (data || "");

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lyricDelete(id: string, options: any = {}): FetchArgs {
            // verify required parameter 'id' is not null or undefined
            if (id === null || id === undefined) {
                throw new RequiredError('id','Required parameter id was null or undefined when calling lyricDelete.');
            }
            const localVarPath = `/lyric/{id}/`
                .replace(`{${"id"}}`, encodeURIComponent(String(id)));
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'DELETE' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Basic required
            // http basic authentication required
            if (configuration && (configuration.username || configuration.password)) {
                localVarHeaderParameter["Authorization"] = "Basic " + btoa(configuration.username + ":" + configuration.password);
            }

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @param {string} [search] A search term.
         * @param {string} [ordering] Which field to use when ordering the results.
         * @param {number} [page] A page number within the paginated result set.
         * @param {number} [size] Number of results to return per page.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lyricList(search?: string, ordering?: string, page?: number, size?: number, options: any = {}): FetchArgs {
            const localVarPath = `/lyric/`;
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Basic required
            // http basic authentication required
            if (configuration && (configuration.username || configuration.password)) {
                localVarHeaderParameter["Authorization"] = "Basic " + btoa(configuration.username + ":" + configuration.password);
            }

            if (search !== undefined) {
                localVarQueryParameter['search'] = search;
            }

            if (ordering !== undefined) {
                localVarQueryParameter['ordering'] = ordering;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (size !== undefined) {
                localVarQueryParameter['size'] = size;
            }

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lyricRead(id: string, options: any = {}): FetchArgs {
            // verify required parameter 'id' is not null or undefined
            if (id === null || id === undefined) {
                throw new RequiredError('id','Required parameter id was null or undefined when calling lyricRead.');
            }
            const localVarPath = `/lyric/{id}/`
                .replace(`{${"id"}}`, encodeURIComponent(String(id)));
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Basic required
            // http basic authentication required
            if (configuration && (configuration.username || configuration.password)) {
                localVarHeaderParameter["Authorization"] = "Basic " + btoa(configuration.username + ":" + configuration.password);
            }

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * LyricApi - functional programming interface
 * @export
 */
export const LyricApiFp = function(configuration?: Configuration) {
    return {
        /**
         * 
         * @param {LyricDetail} data 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lyricCreate(data: LyricDetail, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<LyricDetail> {
            const localVarFetchArgs = LyricApiFetchParamCreator(configuration).lyricCreate(data, options);
            return (fetch: FetchAPI = portableFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * 
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lyricDelete(id: string, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<Response> {
            const localVarFetchArgs = LyricApiFetchParamCreator(configuration).lyricDelete(id, options);
            return (fetch: FetchAPI = portableFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response;
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * 
         * @param {string} [search] A search term.
         * @param {string} [ordering] Which field to use when ordering the results.
         * @param {number} [page] A page number within the paginated result set.
         * @param {number} [size] Number of results to return per page.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lyricList(search?: string, ordering?: string, page?: number, size?: number, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<any> {
            console.log("LISTING")
            const localVarFetchArgs = LyricApiFetchParamCreator(configuration).lyricList(search, ordering, page, size, options);
            return (fetch: FetchAPI = portableFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * 
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lyricRead(id: string, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<LyricDetail> {
            const localVarFetchArgs = LyricApiFetchParamCreator(configuration).lyricRead(id, options);
            return (fetch: FetchAPI = portableFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
    }
};

/**
 * LyricApi - factory interface
 * @export
 */
export const LyricApiFactory = function (configuration?: Configuration, fetch?: FetchAPI, basePath?: string) {
    return {
        /**
         * 
         * @param {LyricDetail} data 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lyricCreate(data: LyricDetail, options?: any) {
            return LyricApiFp(configuration).lyricCreate(data, options)(fetch, basePath);
        },
        /**
         * 
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lyricDelete(id: string, options?: any) {
            return LyricApiFp(configuration).lyricDelete(id, options)(fetch, basePath);
        },
        /**
         * 
         * @param {string} [search] A search term.
         * @param {string} [ordering] Which field to use when ordering the results.
         * @param {number} [page] A page number within the paginated result set.
         * @param {number} [size] Number of results to return per page.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lyricList(search?: string, ordering?: string, page?: number, size?: number, options?: any) {
            return LyricApiFp(configuration).lyricList(search, ordering, page, size, options)(fetch, basePath);
        },
        /**
         * 
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lyricRead(id: string, options?: any) {
            return LyricApiFp(configuration).lyricRead(id, options)(fetch, basePath);
        },
    };
};

/**
 * LyricApi - object-oriented interface
 * @export
 * @class LyricApi
 * @extends {BaseAPI}
 */
export class LyricApi extends BaseAPI {
    /**
     * 
     * @param {LyricDetail} data 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LyricApi
     */
    public lyricCreate(data: LyricDetail, options?: any) {
        return LyricApiFp(this.configuration).lyricCreate(data, options)(this.fetch, this.basePath);
    }

    /**
     * 
     * @param {string} id 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LyricApi
     */
    public lyricDelete(id: string, options?: any) {
        return LyricApiFp(this.configuration).lyricDelete(id, options)(this.fetch, this.basePath);
    }

    /**
     * 
     * @param {string} [search] A search term.
     * @param {string} [ordering] Which field to use when ordering the results.
     * @param {number} [page] A page number within the paginated result set.
     * @param {number} [size] Number of results to return per page.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LyricApi
     */
    public lyricList(search?: string, ordering?: string, page?: number, size?: number, options?: any) {
        return LyricApiFp(this.configuration).lyricList(search, ordering, page, size, options)(this.fetch, this.basePath);
    }

    /**
     * 
     * @param {string} id 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LyricApi
     */
    public lyricRead(id: string, options?: any) {
        return LyricApiFp(this.configuration).lyricRead(id, options)(this.fetch, this.basePath);
    }

}

/**
 * SongApi - fetch parameter creator
 * @export
 */
export const SongApiFetchParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        songDelete(id: string, options: any = {}): FetchArgs {
            // verify required parameter 'id' is not null or undefined
            if (id === null || id === undefined) {
                throw new RequiredError('id','Required parameter id was null or undefined when calling songDelete.');
            }
            const localVarPath = `/song/{id}/`
                .replace(`{${"id"}}`, encodeURIComponent(String(id)));
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'DELETE' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Basic required
            // http basic authentication required
            if (configuration && (configuration.username || configuration.password)) {
                localVarHeaderParameter["Authorization"] = "Basic " + btoa(configuration.username + ":" + configuration.password);
            }

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @param {number} [page] A page number within the paginated result set.
         * @param {number} [size] Number of results to return per page.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        songList(page?: number, size?: number, options: any = {}): FetchArgs {
            const localVarPath = `/song/`;
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Basic required
            // http basic authentication required
            if (configuration && (configuration.username || configuration.password)) {
                localVarHeaderParameter["Authorization"] = "Basic " + btoa(configuration.username + ":" + configuration.password);
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (size !== undefined) {
                localVarQueryParameter['size'] = size;
            }

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        songRead(id: string, options: any = {}): FetchArgs {
            // verify required parameter 'id' is not null or undefined
            if (id === null || id === undefined) {
                throw new RequiredError('id','Required parameter id was null or undefined when calling songRead.');
            }
            const localVarPath = `/song/{id}/`
                .replace(`{${"id"}}`, encodeURIComponent(String(id)));
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'GET' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Basic required
            // http basic authentication required
            if (configuration && (configuration.username || configuration.password)) {
                localVarHeaderParameter["Authorization"] = "Basic " + btoa(configuration.username + ":" + configuration.password);
            }

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * SongApi - functional programming interface
 * @export
 */
export const SongApiFp = function(configuration?: Configuration) {
    return {
        /**
         * 
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        songDelete(id: string, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<Response> {
            const localVarFetchArgs = SongApiFetchParamCreator(configuration).songDelete(id, options);
            return (fetch: FetchAPI = portableFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response;
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * 
         * @param {number} [page] A page number within the paginated result set.
         * @param {number} [size] Number of results to return per page.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        songList(page?: number, size?: number, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<any> {
            const localVarFetchArgs = SongApiFetchParamCreator(configuration).songList(page, size, options);
            return (fetch: FetchAPI = portableFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
        /**
         * 
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        songRead(id: string, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<SongDetail> {
            const localVarFetchArgs = SongApiFetchParamCreator(configuration).songRead(id, options);
            return (fetch: FetchAPI = portableFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
    }
};

/**
 * SongApi - factory interface
 * @export
 */
export const SongApiFactory = function (configuration?: Configuration, fetch?: FetchAPI, basePath?: string) {
    return {
        /**
         * 
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        songDelete(id: string, options?: any) {
            return SongApiFp(configuration).songDelete(id, options)(fetch, basePath);
        },
        /**
         * 
         * @param {number} [page] A page number within the paginated result set.
         * @param {number} [size] Number of results to return per page.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        songList(page?: number, size?: number, options?: any) {
            return SongApiFp(configuration).songList(page, size, options)(fetch, basePath);
        },
        /**
         * 
         * @param {string} id 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        songRead(id: string, options?: any) {
            return SongApiFp(configuration).songRead(id, options)(fetch, basePath);
        },
    };
};

/**
 * SongApi - object-oriented interface
 * @export
 * @class SongApi
 * @extends {BaseAPI}
 */
export class SongApi extends BaseAPI {
    /**
     * 
     * @param {string} id 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SongApi
     */
    public songDelete(id: string, options?: any) {
        return SongApiFp(this.configuration).songDelete(id, options)(this.fetch, this.basePath);
    }

    /**
     * 
     * @param {number} [page] A page number within the paginated result set.
     * @param {number} [size] Number of results to return per page.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SongApi
     */
    public songList(page?: number, size?: number, options?: any) {
        return SongApiFp(this.configuration).songList(page, size, options)(this.fetch, this.basePath);
    }

    /**
     * 
     * @param {string} id 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SongApi
     */
    public songRead(id: string, options?: any) {
        return SongApiFp(this.configuration).songRead(id, options)(this.fetch, this.basePath);
    }

}

/**
 * VoteApi - fetch parameter creator
 * @export
 */
export const VoteApiFetchParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @param {string} id 
         * @param {LyricVote} data 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        voteLyricUpdate(id: string, data: LyricVote, options: any = {}): FetchArgs {
            // verify required parameter 'id' is not null or undefined
            if (id === null || id === undefined) {
                throw new RequiredError('id','Required parameter id was null or undefined when calling voteLyricUpdate.');
            }
            // verify required parameter 'data' is not null or undefined
            if (data === null || data === undefined) {
                throw new RequiredError('data','Required parameter data was null or undefined when calling voteLyricUpdate.');
            }
            const localVarPath = `/vote/lyric/{id}/`
                .replace(`{${"id"}}`, encodeURIComponent(String(id)));
            const localVarUrlObj = url.parse(localVarPath, true);
            const localVarRequestOptions = Object.assign({ method: 'PUT' }, options);
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication Basic required
            // http basic authentication required
            if (configuration && (configuration.username || configuration.password)) {
                localVarHeaderParameter["Authorization"] = "Basic " + btoa(configuration.username + ":" + configuration.password);
            }

            localVarHeaderParameter['Content-Type'] = 'application/json';

            localVarUrlObj.query = Object.assign({}, localVarUrlObj.query, localVarQueryParameter, options.query);
            // fix override query string Detail: https://stackoverflow.com/a/7517673/1077943
            delete localVarUrlObj.search;
            localVarRequestOptions.headers = Object.assign({}, localVarHeaderParameter, options.headers);
            const needsSerialization = (<any>"LyricVote" !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.body =  needsSerialization ? JSON.stringify(data || {}) : (data || "");

            return {
                url: url.format(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * VoteApi - functional programming interface
 * @export
 */
export const VoteApiFp = function(configuration?: Configuration) {
    return {
        /**
         * 
         * @param {string} id 
         * @param {LyricVote} data 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        voteLyricUpdate(id: string, data: LyricVote, options?: any): (fetch?: FetchAPI, basePath?: string) => Promise<LyricVote> {
            const localVarFetchArgs = VoteApiFetchParamCreator(configuration).voteLyricUpdate(id, data, options);
            return (fetch: FetchAPI = portableFetch, basePath: string = BASE_PATH) => {
                return fetch(basePath + localVarFetchArgs.url, localVarFetchArgs.options).then((response) => {
                    if (response.status >= 200 && response.status < 300) {
                        return response.json();
                    } else {
                        throw response;
                    }
                });
            };
        },
    }
};

/**
 * VoteApi - factory interface
 * @export
 */
export const VoteApiFactory = function (configuration?: Configuration, fetch?: FetchAPI, basePath?: string) {
    return {
        /**
         * 
         * @param {string} id 
         * @param {LyricVote} data 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        voteLyricUpdate(id: string, data: LyricVote, options?: any) {
            return VoteApiFp(configuration).voteLyricUpdate(id, data, options)(fetch, basePath);
        },
    };
};

/**
 * VoteApi - object-oriented interface
 * @export
 * @class VoteApi
 * @extends {BaseAPI}
 */
export class VoteApi extends BaseAPI {
    /**
     * 
     * @param {string} id 
     * @param {LyricVote} data 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof VoteApi
     */
    public voteLyricUpdate(id: string, data: LyricVote, options?: any) {
        return VoteApiFp(this.configuration).voteLyricUpdate(id, data, options)(this.fetch, this.basePath);
    }

}

